/***********************************************************************
 
    c++dbc library test program 

    Copyright (C) 2002-2009  Markus Graf, M.Sc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License only.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>

************************************************************************/


/**
 *
 * Version information
 *
 * FILE:
 *  cppdbclibtest.cpp : Defines the entry point for the console application.
 *
 *  implements test functions to test cppdbc lib
 *
 * modification history
 *  2009-03-21 gm   restarted implementing testproject to test the dll-modules outside of the expressRM project
 *
 */

#include "stdafx.h"
#include <iostream>
using namespace std;
#include "../cppdbc/include/c++dbcinc.h"


int _tmain(int argc, _TCHAR* argv[])
{
  char buffer[200];
  
  cout << DatabaseConnectionManager::licenseInformation() << "\n";

  IDatabase* pDB = DatabaseConnectionManager::createDatabaseInterface( DBMS_SqLite );

  if ( pDB->connect( "test.db", NULL, NULL ) )
  {
    int result = pDB->execDML( "create table test (id integer)" );
    result = pDB->execDelete("delete from test where id=2");

/*    result = pDB->execInsert( "insert into test values (1)" );
    result = pDB->execInsert( "insert into test values (2)" ); */
    
    IResultSet* prs = pDB->execQuery( "select * from test" );

    int cols = prs->getColumnCount();
    for (int i=0; i<cols; i++)
    {
      prs->getResultSetMetaData()->getFieldName( i, buffer, 200 );
      cout << buffer << "|";
    }
    cout << "\n-------------------------------------------------------------------------\n";

    while ( prs->next())
    {
      for (int c=0; c<cols; c++)
      {
        prs->getString( c, buffer, 200 );
        cout << buffer << "\t|";
      }
      cout << "\n";
    }
    pDB->freeResultSet( prs );  // delete prs; would work fine too


    pDB->close();
  }
  
  // free database interface
  DatabaseConnectionManager::freeDatabaseInterface( &pDB );

#ifdef DBMS_INCLUDE_MYSQL
  pDB = DatabaseConnectionManager::createDatabaseInterface( DBMS_MySQL );

  if ( pDB->connect("localhost", "test", "root", "") )
  {
    IResultSet* prs = pDB->execQuery("select * from students" );
    int cols = prs->getColumnCount();
    for (int i=0; i<cols; i++)
    {
      prs->getResultSetMetaData()->getFieldName( i, buffer, 200 );
      cout << buffer << "|";
    }
    cout << "\n-------------------------------------------------------------------------\n";

    while ( prs->next())
    {
      for (int c=0; c<cols; c++)
      {
        prs->getString( c, buffer, 200 );
        cout << buffer << "\t|";
      }
      cout << "\n";
    }
    pDB->freeResultSet( prs );    // delete prs; works, too

    pDB->close();
  }

  DatabaseConnectionManager::freeDatabaseInterface( &pDB );
#endif

#ifdef DBMS_INCLUDE_ODBC
  pDB = DatabaseConnectionManager::createDatabaseInterface( DBMS_ODBC );

  if ( pDB->connect("Xtreme Sample Database 2005", NULL, NULL, NULL) )
  {
    IResultSet* prs = pDB->execQuery("select * from [Xtreme Info]" );
    int cols = prs->getColumnCount();
    for (int i=0; i<cols; i++)
    {
      prs->getResultSetMetaData()->getFieldName( i, buffer, 200 );
      cout << buffer << "|";
    }
    cout << "\n-------------------------------------------------------------------------\n";

    while ( prs->next())
    {
      for (int c=0; c<cols; c++)
      {
        prs->getString( c, buffer, 200 );
        cout << buffer << "\t|";
      }
      cout << "\n";
    }
    pDB->freeResultSet( prs );    // delete prs; works, too

    pDB->close();
  }

  DatabaseConnectionManager::freeDatabaseInterface( &pDB );
#endif

  
	return 0;
}

