/***********************************************************************
 
    c++dbc library. A free extensible C++ database connectivity library
    Copyright (C) 2002-2009  Markus Graf, M.Sc.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, version 2 of the License only.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. 

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>

************************************************************************/
/* 
 * modification history
 *  2002-03-20 gm   basis implementation of database connectivity library as part of expressRM (for more information see http://expressrm.grafs-world.de)
 *  ...        gm   a lot undocumented stuff happened due to several time consuming and occupying tasks as my masters degree a.s.o.
 *  2009-03-21 gm   code-review
 */

#if !defined(_IRESULTSETMETADATA_H)
#define _IRESULTSETMETADATA_H

#include "types.h"

/**
 * interface definition for resultset metadata
 * used to retrieve additional information about the result set
 */
class CPPDBC_API IResultSetMetaData
{
public:
  /**
   * returns the number of fields in the resultset (=number of columns)
   * @return number of fields/columns in the resultset
   */
  virtual unsigned int getFieldCount() =0;

  /**
   * returns the field name for field \arg field in the buffer \arg buffer
   * @param field field-number (begins with 0)
   * @param buffer pointer to characterarray (string)
   * @param len length of buffer in bytes
   * @return pointer to buffer (parameter) containing the fieldname of field-number given as \arg field.
   */
  virtual char* getFieldName(int field, char* buffer, int len) =0;
};

#endif  //_IRESULTSETMETADATA_H
